#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
#{scrName} v1.00  Copyright (C) 2005, nomad
Tv: BTONIC `t@C̊eZOg̐擪_vo͂
\: ruby -Ks #{scrName} <dicName>
  <dicName>  t@C (.exi)
:
  ruby -Ks #{scrName} "C:\\Program Files\\SANSEIDO BTONIC Viewer\\CrownFR\\CrownFR.exi"
================================================
end
=begin
o: _vf[^
:
  v1.00 2005-03-06 by nomad
    J
  v1.10 2005-10-23 by nomad
    wb_[̃_vǉ
: Copyright (C) 2005, nomad
      I[v\[X
=end

dumpsize = 256   # _vTCY

# \Zi_v (̋ʂ͖)
def hexdump(data, pos = 0)

  data.scan(/.{1,16}/nm) do |s|
    hexstr = ''
    s.size.times do |n|
      hexstr << ((n == 8) ? '-' : ' ')
      hexstr << '%02X' % [s[n]]
    end

    charstr = ''
    i = 0
    while i < s.size
      case s[i] 
      when 0x81..0x9F, 0xE0..0xFC
        case s[i + 1]
        when 0x40..0x7E, 0x80..0xFC
          charstr << s[i] << s[i + 1]
          i += 1
        else
          charstr << '.'
        end
      when 0x20..0x7E, 0xA0..0xDF
        charstr << s[i]
      else
        charstr << '.'
      end
      i += 1
    end

    puts '%04X:%04X %-48s  %s' % [pos >> 16, pos % 65536, hexstr, charstr]
    pos += 16
  end

end

fname = ARGV.shift

open(fname, 'rb') do |f|
  fname = File::expand_path(fname)
  puts 'NAME: %s' % [fname]
  puts 'TIME: %s' % [File::mtime(fname).strftime('%Y-%m-%d %X')]
  puts 'SIZE: %08Xh (%d)' % [size = File::size(fname), size]
  puts ''
  puts 'HEADER --------'
  hexdump(f.read(64))
  puts ''

  segs = []
  loop do
    pos, size = f.read(8).unpack('NN')
    break if pos.zero?
    segs.push([pos, size])
  end
  puts 'SEGS: %d' % [segs.size]
  puts ''

  n = 0
  segs.each do |pos, size|
    puts 'SEG %2d at %08Xh, size = %08Xh (%d) --------' % [n, pos, size, size]
    f.pos = pos
    hexdump(f.read([dumpsize, size].min))
    puts ''
    n += 1
  end

end
